import javax.sound.midi.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;


public class MidiAufnehmen extends Frame implements KeyListener{
    
    static MidiAufnehmen midi1;
    Sequencer seq;
    Receiver rcvr;
    Synthesizer synth;
    MidiChannel[] channels;
    int instrument;
    Instrument[] inst;
    Soundbank sb;
    
    
    ShortMessage meineMessage=new ShortMessage();
    Sequence meineSequence;
    Track meinTrack;
    
    File file;
    long startTime;
    
    static int tonhoehe = 0;
    
    
    public MidiAufnehmen(){
        super("Midi Aufnehmen");
        addKeyListener(this);
        setBackground(Color.red);
        setSize(400,300);
        setLocation(200,100);
        setVisible(true);
        
        
        
        
        System.out.println("Druecke ESC um die Aufnahme zu beenden und das Midi File abzuspeichern!");
        System.out.println("Druecke Enter um eine Oktave hher zu kommen ");
        System.out.println("Druecke Space um NOCH eine Oktave hher zu kommen ");
        System.out.println("jetzt bitte spielen");
        // Hier alles fr die Aufnahme bereit machen
        
        try{
            
            
            
            seq = MidiSystem.getSequencer();
            synth = MidiSystem.getSynthesizer();
            seq.open();
            synth.open();
            rcvr = seq.getReceiver();
            channels = synth.getChannels();
            sb = synth.getDefaultSoundbank();
            inst = sb.getInstruments();
            instrument = 105;
            
         
            
        }catch(MidiUnavailableException e){System.out.println("Fehler beim Konstruktor!"); System.exit(0);}
       
        try{
        meineSequence = new Sequence(Sequence.PPQ, 10);
        meinTrack = meineSequence.createTrack();
                
        seq.setSequence(meineSequence);
        }catch(InvalidMidiDataException e){System.out.println("Kein gltiges MidiFormat!");System.exit(0);}
        
        seq.recordEnable(meinTrack, 0);
        //seq.startRecording();
        startTime = System.currentTimeMillis();
        addMessageToTrack(ShortMessage.PROGRAM_CHANGE, 0, 105, 0);
        channels[0].programChange(instrument);
        
    }//Konstruktor ENDE
    
    private void addMessageToTrack(int command, int channel, int data1, int data2) {
        meineMessage = new ShortMessage();
        try {
            long tick = (System.currentTimeMillis()-startTime)*meineSequence.getResolution() / 500;
            meineMessage.setMessage(command, channel, data1, data2);
            meinTrack.add(new MidiEvent(meineMessage, tick));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public void keyPressed(KeyEvent event) {
        char key1 = event.getKeyChar();
        if(key1 == KeyEvent.VK_ENTER)
        {MidiAufnehmen.tonhoehe = 12;
         //System.exit(0);
        }
        if(key1==KeyEvent.VK_SPACE)
        { MidiAufnehmen.tonhoehe = 24;}
        
        if(key1==KeyEvent.VK_ESCAPE)
        { seq.stopRecording();
          file = new File("my.mid");
          try {
              MidiSystem.write(meineSequence, 0, file);
          }catch(IOException e){}
          seq.stop();
          try{
              Thread.sleep(5000);
          }
          catch(InterruptedException e) {}
          MidiAbspielen midiabspielen = new MidiAbspielen();
        }
        
        
    }
    
    public void keyReleased(KeyEvent event) {
        char key = event.getKeyChar();
        meineMessage = new ShortMessage();
        long tick = (System.currentTimeMillis() -
            startTime)*meineSequence.getResolution() / 500;
        
        if(key == 'c'){
                addMessageToTrack(ShortMessage.NOTE_OFF, 0, tonhoehe+ 60, 93);
                channels[0].noteOff(tonhoehe+60,93);
        }
        if(key == 'd'){
            addMessageToTrack(ShortMessage.NOTE_OFF, 0, tonhoehe+ 62, 93);
            channels[0].noteOff(tonhoehe+62,93);
        }
        if(key == 'e'){
            addMessageToTrack(ShortMessage.NOTE_OFF, 0, tonhoehe+ 64, 93);
            channels[0].noteOff(tonhoehe+64,93);}
        
        if(key == 'f'){
            addMessageToTrack(ShortMessage.NOTE_OFF, 0, tonhoehe+ 65, 93);
            channels[0].noteOff(tonhoehe+65,93);}
        if(key == 'g'){
            addMessageToTrack(ShortMessage.NOTE_OFF, 0, tonhoehe+ 67, 93);
            channels[0].noteOff(tonhoehe+67,93);}
        if(key == 'a'){
            addMessageToTrack(ShortMessage.NOTE_OFF, 0, tonhoehe+ 69, 93);
            channels[0].noteOff(tonhoehe+69,93);}
        if(key == 'h'){
            addMessageToTrack(ShortMessage.NOTE_OFF, 0, tonhoehe+ 71, 93);
            channels[0].noteOff(tonhoehe+71,93);}
        if(key == 'x'){
            addMessageToTrack(ShortMessage.NOTE_OFF, 0, tonhoehe+ 96, 93);
            channels[0].noteOff(96,93);}
    }
    
    
    public void keyTyped(KeyEvent event) {
        char key = event.getKeyChar();
        meineMessage = new ShortMessage();
        long tick = (System.currentTimeMillis()-startTime)*meineSequence.getResolution() / 500;
        
        /*
        try{
            meineMessage.setMessage(ShortMessage.PROGRAM_CHANGE,0,105,0);
            rcvr.send(meineMessage, -1);
            //seq.setTrackMute(0,true);
            //meinTrack.add(new MidiEvent(meineMessage, 0));
        }catch(Exception e){e.printStackTrace();}
        */
        
        if(key == 'c') {
                addMessageToTrack(ShortMessage.NOTE_ON, 0, tonhoehe+ 60, 93);
                channels[0].noteOn(tonhoehe+60,93);
        }
        
        if(key== 'd') {

                addMessageToTrack(ShortMessage.NOTE_ON,  0, tonhoehe+62, 93);
                //rcvr.send(meineMessage, -1);
                //meinTrack.add(new MidiEvent(meineMessage, 0));
                channels[0].noteOn(tonhoehe+62,93);

        }
        if(key== 'e') {

                addMessageToTrack(ShortMessage.NOTE_ON, 0, tonhoehe+64, 93);
                //meinTrack.add(new MidiEvent(meineMessage, 0));
                channels[0].noteOn(tonhoehe+64,93);
                
                //rcvr.send(meineMessage, -1);

        }
        if(key== 'f') {

                addMessageToTrack(ShortMessage.NOTE_ON, 0, tonhoehe+65, 93);
                //meinTrack.add(new MidiEvent(meineMessage, 0));
                channels[0].noteOn(tonhoehe+65,93);
                //rcvr.send(meineMessage, -1);

        }
        if(key== 'g') {

                addMessageToTrack(ShortMessage.NOTE_ON, 0, tonhoehe+67, 93);
                //meinTrack.add(new MidiEvent(meineMessage, 0));
                channels[0].noteOn(tonhoehe+67,93);
                //rcvr.send(meineMessage, -1);

        }
        if(key== 'a') {

                addMessageToTrack(ShortMessage.NOTE_ON, 0, tonhoehe+69, 93);
                //meinTrack.add(new MidiEvent(meineMessage, 0));
                channels[0].noteOn(tonhoehe+69,93);
                //rcvr.send(meineMessage, -1);

        }
        
        if(key== 'h') {
  
                addMessageToTrack(ShortMessage.NOTE_ON, 0, tonhoehe+71, 93);
                //meinTrack.add(new MidiEvent(meineMessage, 0));
                channels[0].noteOn(tonhoehe+71,93);
                //rcvr.send(meineMessage, -1);
        
        }
        
        if(key== 'x') {
     
                addMessageToTrack(ShortMessage.NOTE_ON, 0,   96, 93);
                //meinTrack.add(new MidiEvent(meineMessage, 0));
                channels[0].noteOn(tonhoehe+96,93);
                //rcvr.send(meineMessage, -1);
      
        }
        
    }
    
    
    
    public static void main(String[] args)
    {  midi1 = new MidiAufnehmen();
       
       
    }
    
}

