
import javax.sound.sampled.*;
import java.io.*;

class MikroAufnahme extends Thread {
    static AudioInputStream stream = null;
    static AudioFormat neuesFormat;
    static byte[] ba = null;
    static int AnzahlGelBytes = 0;
    static boolean aufnahme = true;
    static SourceDataLine sourceLine_2 = null;
    static TargetDataLine targetLine_1 = null;
    static ByteArrayOutputStream baOut = null;
    static DataLine.Info info, info2;
    static FloatControl gainControl;

    public MikroAufnahme() {

        // Neues und geeignetes Audio Format bestimmen

        neuesFormat = new AudioFormat((float) 11025.0, 16, 2, true, false);


        // welche Art von Line soll angefordert werden

        info = new DataLine.Info(TargetDataLine.class, neuesFormat);
        info2 = new DataLine.Info(SourceDataLine.class, neuesFormat);

        //Line wird angefordert

        try {

            targetLine_1 = (TargetDataLine) AudioSystem.getLine(info);
            sourceLine_2 = (SourceDataLine) AudioSystem.getLine(info2);
        } catch (LineUnavailableException e) {
            System.out.println("MikroAufnahme: Keine TargetDataLine/SourceDataLine frei");
            System.exit(1);
        }

        //offne Line

        try {
            targetLine_1.open(neuesFormat);
            sourceLine_2.open();
        } catch (LineUnavailableException e) {
            System.out.println("MikroAufnahme: TargetDataLine konnte nicht geffnet werden");
            System.exit(1);
        }

    }

    public void run() {
        baOut = new ByteArrayOutputStream();
        int AnzahlGelBytes = 0;

        //Buffer in das aufgenommene Daten eingelesen werden
        ba = new byte[64];

        //Starten der Line zum Aufnehmen des Sounds
        targetLine_1.start();

        // LAUTSTKRE FESTGELEGT
        if (sourceLine_2.isControlSupported(FloatControl.Type.MASTER_GAIN)) {

            gainControl = (FloatControl) sourceLine_2.getControl(FloatControl.Type.MASTER_GAIN);
        }
        gainControl.setValue(10.0f);

        sourceLine_2.start();

        while (aufnahme) {
            //lese Sounddaten in buffer ein

            AnzahlGelBytes = targetLine_1.read(ba, 0, ba.length);
            sourceLine_2.write(ba, 0, AnzahlGelBytes);

            baOut.write(ba, 0, AnzahlGelBytes);


        }
        targetLine_1.drain();
        targetLine_1.stop();
        targetLine_1.close();
    }



}

